utility MeshFixUtil "Meshfix Utility"
(
	rollout windingRollout "Winding Numbers"                                                            
	(
		button fixButton "Fix.." width:75

		on fixButton pressed do                                                                    
		(
			include "global.ms"

			obj = selection[1]
			
			-- Merge selection into a single mesh
			if (selection.count > 1) then
			(
				obj = editable_mesh()
				obj.name = (selection[1].name + "_multi")
				
				for o in selection do
				(
					n = snapshot o
					attach obj n
				)
			)
			
			-- Save mesh to OFF file
			pathToScript = "C:/Temp/winding_demo_win32/"
			fileName = (pathToScript + obj.name) + ".obj"
			saveAsOBJ obj fileName

			changedir = (" cd " + pathToScript)
			
			fix_script = changedir +" & matlab -nojvm -wait -nosplash -nodesktop -nodisplay -minimize  -r \"fixMesh '" + fileName + "';exit\""
				
			-- Run Meshfix script
			DOSCommand fix_script
			
			outputFilename = (pathToScript + obj.name) + "_fixed.obj";

			-- Load fixed OBJ file
			m = loadOBJ(outputFilename)
			
			addmodifier m (Normalmodifier flip:true)
			convertToMesh m
			CenterPivot m
			
			-- Clean up
			DOSCommand ("del.exe " + fileName)
			DOSCommand ("del.exe " + outputFilename)
		)
	)
	
	rollout meshFixRollout "Meshfix-Attene"                                                            
	(
		button fixButton "Fix.." width:75
		button convertAllButton "Convert to meshes.."
		
		on fixButton pressed do                                                                     
		(
			include "global.ms"
			
			for obj in selection do
			(
				-- Save mesh to OFF file
				fileName = obj.name + ".off"
				saveOFF obj fileName

				currentPath = getFilenamePath (getSourceFileName())
				meshfix_exe = currentPath + "mesh_fix.exe"
				
				print meshfix_exe
					
				-- Run Meshfix on saved file
				fixCmd = meshfix_exe + " " + fileName
				print fixCmd
				DOSCommand fixCmd
		
				-- Load fixed OFF file
				m = loadOFF (obj.name + "_fixed.off")
				CenterPivot m
					
				-- Delete temp and fixed files
				DOSCommand ("del.exe " + fileName)
				DOSCommand ("del.exe " + (obj.name + "_fixed.off"))
			)
		)
	)
	
	rollout corkRollout "Boolean / CSG using Cork library"                                                            
	(
		button joinButton "Join.." width:75

		on joinButton pressed do                                                                     
		(
			file_names = #()
			
			include "global.ms"
			
			prevFilename = "output.off"
			saveOFF selection[1] prevFilename
		
			for i = 1 to (selection.count) do
			(
				if(i==1) then continue
				
				curFilename = selection[i].name + ".off"
				saveOFF selection[i] curFilename
				
				cmd = ("wincork.exe -union " + prevFilename + " " + curFilename + " " + prevFilename)
				DOSCommand( cmd )
				
				deleteFile curFilename
			)
			
			m = loadOFF( prevFilename )
			CenterPivot m
			
			deleteFile prevFilename
		)
	)
	
	on MeshFixUtil open do
	(
		addRollout meshFixRollout
		addRollout windingRollout
		addRollout corkRollout
	)
	
	on MeshFixUtil close do
	(
		removeRollout meshFixRollout
		removeRollout windingRollout
		removeRollout corkRollout
	) 
)
